//+------------------------------------------------------------------+
//|                                                      Live_MA.mq4 |
//|                                          Copyright  2009, DRKNN |
//|                                                    drknn@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, DRKNN"
#property link      "drknn@mail.ru"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---------   -----------
extern string c0="--------   -----------";
extern int    Start_Period=96;
extern int    Shift=0;//    . 
extern int    Metod=0;/*   MODE_SMA
                          0    
                          1    
                          2    
                          3 -   */
extern int    Price=4;/*    
                         0   
                         1   
                         2   
                         3   
                         4  , (high+low)/2 
                         5  , (high+low+close)/3 
                         6   , (high+low+close+close)/4 */
//---------   -------------------
double ExtMapBuffer1[];
// --------   ---------
double     Period_MA; //     
int     CountBars;//  
string  SMB;
double    Middle1,Middle2,Middle3,OldRasst,NewRasst,VoSkolkoRaz;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//----
   SMB=Symbol();
   Period_MA= Start_Period;
   Period_MA=NormalizeDouble(Period_MA,0);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
   
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  if(Bars<Start_Period){
    
    Alert("   .     .");
    Alert("--------- ","Live_MA  ",SMB," ---------");
    return(0);
  }
  //int    counted_bars=IndicatorCounted();
  
  if(isNewBar()){//    ,     
    Middle1=(High[1]-Low[1])/2;
    Middle2=(High[2]-Low[2])/2;
    Middle3=(High[3]-Low[3])/2;
    // ------       ----------
    if(Middle3<Middle2){//  
      OldRasst=(Middle2-Middle3)/Point;
    }
    if(Middle3>Middle2){//  
      OldRasst=(Middle3-Middle2)/Point;
    }
    // ------       ----------
    if(Middle2<Middle1){//  
      NewRasst=(Middle1-Middle2)/Point;
    }
    if(Middle2>Middle1){//  
      NewRasst=(Middle2-Middle1)/Point;
    }
    // ---------   ---------------------------
    if(OldRasst<NewRasst){ //   -    
      VoSkolkoRaz=NewRasst/OldRasst;
      Period_MA=Start_Period/VoSkolkoRaz;
      Period_MA=NormalizeDouble(Period_MA,0);
      if(Period_MA<1){
        Period_MA=1;
      }
    }
    if(OldRasst>NewRasst){ //   -    
      VoSkolkoRaz=OldRasst/NewRasst;
      Period_MA=Start_Period*VoSkolkoRaz;
      Period_MA=NormalizeDouble(Period_MA,0);
      if(Period_MA<1){
        Period_MA=1;
      }
    }
    Print("Period_MA = ",Period_MA);
    Print("ExtMapBuffer1[1] = ",ExtMapBuffer1[1]);
  }
  
  // ------       ------------------
  
  double PRR=0;
  for(int i=Period_MA;i>=1;i--){
    if(i==Period_MA){
      PRR=(High[i]+Low[i])/2;
    }
    else{
      PRR=(PRR+(High[i]+Low[i])/2)/2;
    }
  }
  PRR=NormalizeDouble(PRR,Digits);
  ExtMapBuffer1[0]=PRR;
  //ExtMapBuffer1[0]=iMA(SMB,0,Period_MA,0,Metod,Price,1); 

   return(0);
  }
//+------------------------------------------------------------------+
//                                       |
// ------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  isNewBar() -                                                  |
//+------------------------------------------------------------------+
bool isNewBar(){
  bool rez=false;
  if(CountBars!=Bars){
    rez=true;
    CountBars=Bars;
  }   
//----
   return(rez);
}
//--------------------------------------------------------------- 